com.smartgwt.client.widgets.drawing

## Class DrawRect

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawRect

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawRect
      extends DrawItem

  DrawItem subclass to render rectangle shapes, optionally with rounded corners.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawRect()`
    `DrawRect(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `Point` | `getCenter()` Get the center point of the rectangle.
    `int` | `getHeight()` Height in pixels relative to the `local coordinate system`.
    `int` | `getLeft()` Left coordinate in pixels relative to the `local coordinate system`.
    `LineCap` | `getLineCap()` Style of drawing the endpoints of a line.
    `static DrawRect` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `float` | `getRounding()` Rounding of corners, from 0 (square corners) to 1.0 (shorter edge is a semicircle).
    `TitleRotationMode` | `getTitleRotationMode()` The mode in which the `titleLabel` (if shown) is rotated with this draw item.
    `int` | `getTop()` Top coordinate in pixels relative to the `local coordinate system`.
    `int` | `getWidth()` Width in pixels relative to the `local coordinate system`.
    `boolean` | `isPointInPath(int x, int y)` Returns true if the given point in the drawing coordinate system is within this DrawItem's shape, taking into account local transforms.
    `void` | `moveBy(int dX, int dY)` Move the drawRect by the specified delta
    `void` | `moveTo(java.lang.Integer left, java.lang.Integer top)` Move the drawRect to the specified position
    `void` | `resizeBy(int dX, int dY)` Resize by the specified delta
    `void` | `resizeTo(java.lang.Integer width, java.lang.Integer height)` Resize to the specified size
    `void` | `setCenter(int left, int top)` Move the drawRect such that it is centered over the specified coordinates.
    `static void` | `setDefaultProperties(DrawRect drawRectProperties)` Class level method to set the default properties of this class.
    `void` | `setHeight(int height)` Height in pixels relative to the `local coordinate system`.
    `void` | `setLeft(int left)` Left coordinate in pixels relative to the `local coordinate system`.
    `void` | `setLineCap(LineCap lineCap)` Style of drawing the endpoints of a line.
    `void` | `setRect(java.lang.Integer left, java.lang.Integer top, java.lang.Integer width, java.lang.Integer height)` Move and resize the drawRect to match the specified coordinates and size.
    `void` | `setRounding(float rounding)` Rounding of corners, from 0 (square corners) to 1.0 (shorter edge is a semicircle).
    `void` | `setTitleRotationMode(TitleRotationMode titleRotationMode)` The mode in which the `titleLabel` (if shown) is rotated with this draw item.
    `void` | `setTop(int top)` Top coordinate in pixels relative to the `local coordinate system`.
    `void` | `setWidth(int width)` Width in pixels relative to the `local coordinate system`.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, changeAutoChildDefaults, changeAutoChildDefaults, changeAutoChildDefaults, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getBoundingBoxAsDouble, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getEditProxyConstructor, getEndArrow, getEndKnob, getEventOpaque, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getKnobs, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getRotation, getRotationAsDouble, getScale, getShadow, getShowHover, getShowResizeOutline, getShowTitleLabelBackground, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTitle, getTitleLabel, getTitleLabelBackground, getTitleLabelPadding, getTranslate, getXShearFactor, getYShearFactor, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, rotateBy, rotateTo, scaleBy, scaleTo, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEditProxyConstructor, setEndArrow, setEventOpaque, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setKnobs, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setRotation, setRotation, setScale, setShadow, setShapeData, setShowHover, setShowResizeOutline, setShowTitleLabelBackground, setStartArrow, setTitle, setTitleLabelPadding, setTranslate, setXShearFactor, setYShearFactor, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setID, setJavaScriptObject, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawRect

          public DrawRect()

    - #### DrawRect

          public DrawRect(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawRect getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setHeight

          public void setHeight(int height)

      Height in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the height of the drawRect
      Parameters:
        `height` - new height. Default value is 100

    - #### getHeight

          public int getHeight()

      Height in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setLeft

          public void setLeft(int left)

      Left coordinate in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the left coordinate of the drawRect
      Parameters:
        `left` - new left coordinate. Default value is 0

    - #### getLeft

          public int getLeft()

      Left coordinate in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setLineCap

          public void setLineCap(LineCap lineCap)

      Style of drawing the endpoints of a line.

      Note that for dashed and dotted lines, the lineCap style affects each dash or dot.

      Overrides:
        `setLineCap` in class `DrawItem`
      Parameters:
        `lineCap` - Default value is "butt"

    - #### getLineCap

          public LineCap getLineCap()

      Style of drawing the endpoints of a line.

      Note that for dashed and dotted lines, the lineCap style affects each dash or dot.

      Overrides:
        `getLineCap` in class `DrawItem`
      Returns:
        LineCap

    - #### setRounding

          public void setRounding(float rounding)
                           throws java.lang.IllegalStateException

      Rounding of corners, from 0 (square corners) to 1.0 (shorter edge is a semicircle).
      If this method is called after the component has been drawn/initialized: Setter method for `rounding`
      Parameters:
        `rounding` - new rounding value. Should be between zero (a rectangle) and 1 (shorter edge is a semicircle). Default value is 0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRounding

          public float getRounding()

      Rounding of corners, from 0 (square corners) to 1.0 (shorter edge is a semicircle).
      Returns:
        float

    - #### setTitleRotationMode

          public void setTitleRotationMode(TitleRotationMode titleRotationMode)
                                    throws java.lang.IllegalStateException

      The mode in which the `titleLabel` (if shown) is rotated with this draw item.

      Note : This is an advanced setting

      Overrides:
        `setTitleRotationMode` in class `DrawItem`
      Parameters:
        `titleRotationMode` - Default value is "withItemAlwaysUp"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `DrawItem.setTitle(java.lang.String)`

    - #### getTitleRotationMode

          public TitleRotationMode getTitleRotationMode()

      The mode in which the `titleLabel` (if shown) is rotated with this draw item.
      Overrides:
        `getTitleRotationMode` in class `DrawItem`
      Returns:
        TitleRotationMode
      See Also:
        `DrawItem.getTitle()`

    - #### setTop

          public void setTop(int top)

      Top coordinate in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the top coordinate of the drawRect
      Parameters:
        `top` - new top coordinate. Default value is 0

    - #### getTop

          public int getTop()

      Top coordinate in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setWidth

          public void setWidth(int width)

      Width in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the width of the drawRect
      Parameters:
        `width` - new width. Default value is 100

    - #### getWidth

          public int getWidth()

      Width in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### getCenter

          public Point getCenter()

      Get the center point of the rectangle.
      Overrides:
        `getCenter` in class `DrawItem`
      Returns:
        the center point

    - #### isPointInPath

          public boolean isPointInPath(int x,
                                       int y)

      Returns true if the given point in the drawing coordinate system is within this DrawItem's shape, taking into account local transforms.
      Overrides:
        `isPointInPath` in class `DrawItem`
      Parameters:
        `x` - X coordinate of the test point.
        `y` - Y coordinate of the test point.
      Returns:

    - #### moveBy

          public void moveBy(int dX,
                             int dY)

      Move the drawRect by the specified delta
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to move horizontally
        `dY` - number of pixels to move vertically

    - #### moveTo

          public void moveTo(java.lang.Integer left,
                             java.lang.Integer top)

      Move the drawRect to the specified position
      Overrides:
        `moveTo` in class `DrawItem`
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate

    - #### resizeBy

          public void resizeBy(int dX,
                               int dY)

      Resize by the specified delta
      Overrides:
        `resizeBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to resize by horizontally
        `dY` - number of pixels to resize by vertically

    - #### resizeTo

          public void resizeTo(java.lang.Integer width,
                               java.lang.Integer height)

      Resize to the specified size
      Overrides:
        `resizeTo` in class `DrawItem`
      Parameters:
        `width` - new width
        `height` - new height

    - #### setCenter

          public void setCenter(int left,
                                int top)

      Move the drawRect such that it is centered over the specified coordinates.
      Parameters:
        `left` - left coordinate for new center position
        `top` - top coordinate for new center postiion

    - #### setRect

          public void setRect(java.lang.Integer left,
                              java.lang.Integer top,
                              java.lang.Integer width,
                              java.lang.Integer height)

      Move and resize the drawRect to match the specified coordinates and size.
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate
        `width` - new width
        `height` - new height

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawRect drawRectProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `drawRectProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`